<?php

namespace Bixo\Asset\Http\Controllers;

use App\Http\Controllers\ActionController as BaseController;
use Exception;
use Bixo\Asset\Actions\AssetReport;
use Bixo\Asset\Http\Requests\AssetReportRequest;

/**
 * Admin web controller class.
 */
class AssetReportController extends BaseController
{
    /**
     * Action controller function for asset.
     *
     * @param Model $model
     * @param action next action for the model.
     *
     * @return Response
     */
    public function __invoke(AssetReportRequest $request, $report)
    {
        try {
        
            $this->model = app(Asset::class);
            $data = AssetReport::run($request, $report);

            return $this->response->message(trans('messages.success.updated', ['Module' => trans('asset::asset.name')]))
                ->code(204)
                ->data(compact('data'))
                ->status('success')
                ->url(guard_url('asset/asset/' . $report))
                ->redirect();
        } catch (Exception $e) {
            return $this->response->message($e->getMessage())
                ->code(400)
                ->status('error')
                ->url(guard_url('asset/asset/' . $report))
                ->redirect();
        }
    }
}
